% PROFESSIONS
%
% Smith, Baker, Carpenter and Tailor have each a profession
% (smith, baker, carpenter, tailor) but not showed by their names.
% 
% Each of them has a son.
% But the sons also do not have the profession showed by their name.
% 
% If you know that:
% 1) no son has the same profession as his father has
% and
% 2) Baker has the same profession as Carpenter's son has
% and
% 3) Smith's son is a baker.
% 
% find the professions of the parents and sons.

profession(smith).
profession(baker).
profession(carpenter).
profession(tailor).

professions([(smith,Ps), (baker, Pb), (carpenter,Pc), (tailor, Pt)], 
             [(son_of(smith),Pss), (son_of(baker),Pbs), (son_of(carpenter), Pcs), (son_of(tailor), Pts)]) :-
  profession(Ps), profession(Pb), profession(Pc), profession(Pt),
  profession(Pss), profession(Pbs), profession(Pcs), profession(Pts),
  % Profession is different from name
  Ps \= smith,
  Pb \= baker,
  Pc \= carpenter,
  Pt \= tailor,
  % Son's professions are different from name
  Pss \= smith,
  Pbs \= baker,
  Pcs \= carpenter,
  Pts \= tailor,
  % No son has the same profession as his father
  Ps \= Pss,
  Pb \= Pbs,
  Pc \= Pcs,
  Pt \= Pts,
  % Baker has the same profession as Carpenter's son
  Pb = Pcs,
  % Smith's son is a baker
  Pss = baker,
  % Professions don't repeat
  Ps \= Pb, Ps \= Pc, Ps \= Pt, Pb \= Pc, Pb \= Pt, Pc \= Pt,
  Pss \= Pbs, Pss \= Pcs, Pss \= Pts, Pbs \= Pcs, Pbs \= Pts, Pcs \= Pts.

